<script setup>
// imports
import ProductCard from '@/components/products/ProductCard.vue'
import ButtonComponent from '@/components/base/ButtonComponent.vue'
import PageHeader from '@/components/base/PageHeader.vue'
import LoadingComponent from '@/components/base/LoadingComponent.vue'
import { useProductsStore } from '@/core/stores/products'
import { ref } from 'vue'
import { useHead } from '@vueuse/head'

// data
const showAll = ref(false)
const products = useProductsStore()
if (products.list.length === 0) products.getAllProducts()

//head
useHead({
  title: 'Dolphino challenge | Home',
  meta: [
    {
      name: `description`,
      content: 'This is our home page, you can see our latest products'
    },
    {
      name: 'keywords',
      content: 'shop,product,mobile,laptop,tablet'
    },
    {
      meta: 'og:title',
      content: 'Dolphino challenge | Home'
    },
    {
      meta: 'og:site_name',
      content: 'Dolphino challenge'
    },
    {
      meta: 'url',
      content: 'https://test.com'
    },
    {
      meta: 'og:description',
      content: 'This is our home page, you can see our latest products'
    },
    {
      meta: 'og:type',
      content: 'website'
    },
    {
      meta: 'og:image',
      contetn: 'https://address-of-site-logo.com'
    }
  ]
})
</script>
<template>
  <div>
    <!--loading-->
    <LoadingComponent :loading="products.loading" />

    <!--page header-->
    <PageHeader title="Home" description="You can see our latest products here" />

    <!--product lists-->
    <div
      v-if="products.list.length > 0"
      class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 gap-6 mt-10"
    >
      <ProductCard
        v-for="product in products.list?.slice(0, 6)"
        :key="product.id"
        :product="product"
      />
    </div>

    <Transition name="fade">
      <div v-if="showAll">
        <div
          v-if="products.list.length > 0"
          class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 gap-6 mt-10"
        >
          <ProductCard
            v-for="product in products.list?.slice(6, products.list.length)"
            :key="product.id"
            :product="product"
          />
        </div>
      </div>
    </Transition>

    <!--show more products button-->
    <ButtonComponent
      v-if="!showAll"
      @onButtonClick="showAll = true"
      type="button"
      title="Show more products"
      class="!block !w-fit !mx-auto mt-10"
    >
      Show more products
    </ButtonComponent>
  </div>
</template>

<style scoped>
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s ease;
}

.fade-enter-from,
.fade-leave-to {
  /* opacity: 0; */
  opacity: 0;
}
</style>
